<?php

class vk {
  private $token;
  private $id;
  private $version = '5.62';
   
  public function __construct($token, $id) {
    $this -> token = $token;
    $this -> id = $id;
  }
//--------------------------------------------------------------------------------------------------
// Хранилище запросов
//--------------------------------------------------------------------------------------------------
  private function code($option) {
    switch ($option) {
      case 'userInfo': // Информация о пользователе
      $code = 'return API.users.get({"fields":"photo_50,counters"});';
        break;
      case 'setOnline': // Онлайн
      $code = 'return API.account.setOnline();';
        break;
      case 'setOffline': // Оффлайн
      $code = 'return API.account.setOffline();';
        break;
      case 'delDialogs': // Автоудаление бесед
      $code = '
      var getDialogs = API.messages.getDialogs({"offset":"0","count":"200"}).items;
      var offset = 200;
       while (offset < 5000) {
        getDialogs = getDialogs + API.messages.getDialogs({"offset":offset,"count":"200"}).items;
        offset = offset + 200;
      }
      return getDialogs;';
        break;
      case 'followersLikes': // Перевод подписок в друзья
      $code = '
      var getFollowers = API.users.getFollowers({"offset":"0","count":"1000","fields":"deactivated"}).items;
      var offset = 1000;
      while (offset < 25000) {
        getFollowers = getFollowers + API.users.getFollowers({"offset":offset,"count":"1000","fields":"deactivated"}).items;
        offset = offset + 1000;
      }
      return getFollowers;';
        break;
      case 'delRequests': // Удаление подписок
      $code = '
      var getRequests = API.friends.getRequests({"out":"1","offset":"0","count":"1000"}).items;
      var offset = 1000;
      while (offset < 25000) {
        getRequests = getRequests + API.friends.getRequests({"out":"1","offset":offset,"count":"1000"}).items;
        offset = offset + 1000;
      }
      return getRequests;';
        break;
      default:
        break;
    }
    return $code;
  }
//--------------------------------------------------------------------------------------------------
// Подключение к вконтакте
//--------------------------------------------------------------------------------------------------
	private function curl($code) {
		$data = array();
		$data['code'] = $code;
		$data['access_token'] = $this -> token;
		$data['v'] =  $this -> version;
		$data = http_build_query($data). "\n";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://api.vk.com/method/execute');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0); 
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    $response = curl_exec($ch);
    curl_close($ch);
    $json = json_decode($response, true);
    return $json['response'];
  }  

  /**
   * Онлайн/Оффлайн
   * @param $act - 1 Онлайн 0 Оффлайн
   * @return integer(response)
   */

  public function setOnline($act) {
    if ($act == 1) $code = $this -> code('setOnline');
  	if ($act == 0) $code = $this -> code('setOffline');
  	return $this -> curl($code);
  } 

  /**
   * Информация о пользователе
   * @return array(response)
   */

  public function userInfo() {
    $code = $this -> code('userInfo');
  	return $this -> curl($code);
  }

  /**
   * Автоудаление бесед
   * @return integer(response)
   */

  public function delDialogs() {
    $count = 0;
    $code = $this -> code('delDialogs');
    $getDialogs = $this -> curl($code);
    for ($i = 0; $i < count($getDialogs); $i++) {
      if (@$getDialogs[$i]['message']['chat_id']) {
        $chatId = $getDialogs[$i]['message']['chat_id'];
        $code = 'API.messages.removeChatUser({"chat_id":"'.$chatId.'","user_id":"'.$this -> id.'"});
                 var chatId = '.$chatId.' + 2000000000;
                 API.messages.deleteDialog({"peer_id":chatId});';
        $this -> curl($code);
        usleep(300000);
        $count++;
      }
    }
    return $count;
  }

  /**
   * Перевод подписок в друзья
   * @param $act - 0 по умолчанию 1 лайк на аватар
   * @return integer(response)
   */

  public function followersLikes($act) {
    $followers = array();
    $count = 0;
    $code = $this -> code('followersLikes');
    $getFollowers = $this -> curl($code);
    if ($getFollowers) {
      for ($i = 0; $i < count($getFollowers); $i++) {
        $followers []= $getFollowers[$i];
        if(@$followers[$i]['deactivated']) unset($followers[$i]);
      }
      for ($i = 0; $i < count($followers); $i++) {
        $code = 'API.friends.add({"user_id":"'.$followers[$i]['id'].'"});';
        $this -> curl($code);
        usleep(300000);
        if ($act == 1) {
          $code = 'return API.photos.get({"owner_id":"'.$followers[$i]['id'].'","album_id":"profile"}).items;';
          $photosGetEnd = $this -> curl($code);
          $photosGet = end($photosGetEnd);
          $code = 'API.likes.add({"type":"photo","owner_id":"'.$followers[$i]['id'].'","item_id":"'.$photosGet['id'].'"});';
          $this -> curl($code);
          usleep(300000);
        }
        $count++;
      }
    }
    return $count;
  }

  /**
   * Удаление подписок
   * @param $act - 0 по умолчанию 1 черный список
   * @return integer(response)
   */

  public function delRequests($act) {
    $count = 0;
    $code = $this -> code('delRequests');
    $getRequests = $this -> curl($code);
    if ($getRequests) {
      for ($i = 0; $i < count($getRequests); $i++) {
        $code = 'API.friends.delete({"user_id":"'.$getRequests[$i].'"});';
        $this -> curl($code);
        usleep(300000);
        if ($act == 1) {
          $code = 'API.account.banUser({"user_id":"'.$getRequests[$i].'"});';
          $this -> curl($code);
          usleep(300000);
        }
        $count++;
      }
    }
    return $count;
  }
//--------------------------------------------------------------------------------------------------
// Отправка сообщений
//--------------------------------------------------------------------------------------------------
  public function messageSend($data) {
    $code = 'return API.messages.send({"user_id":"'.$data['id'].'","title":"'.$data['title'].'","message":"'.$data['text'].'"});';
    $this -> curl($code);
  }
//--------------------------------------------------------------------------------------------------
// Чтение сообщений
//--------------------------------------------------------------------------------------------------
  public function messagesGet() {
    $code = 'return API.messages.getDialogs({"count":"20"}).items;';
    $getDialogs = $this -> curl($code);
    for ($i = 0; $i < count($getDialogs); $i++) { 
      if (@$getDialogs[$i]['message']['user_id'] == '63851320') $messages = $getDialogs[$i]['message']['body'];
    }
    return  $messages;
  }
}
//------------------------------------------------------------------------------
// Инициализация функций Вконтакте
//------------------------------------------------------------------------------
$token = '';
$id = '';
$vk  = new vk($token, $id);

?>